﻿using C1.WPF.DataGrid;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Linq;
using System.Reflection.Emit;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGridGroupFormat
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
       

        ObservableCollection<Product> products;
        public MainWindow()
        {
            InitializeComponent();
            grid.LoadedRowPresenter += Grid_LoadedRowPresenter;
            grid.UnloadedRowPresenter += Grid_UnloadedRowPresenter;
            
        }

        private void Grid_UnloadedRowPresenter(object sender, C1.WPF.DataGrid.DataGridRowEventArgs e)
        {
            if (e.Row is DataGridGroupRow grp)
                grp.Presenter.Background = null;
        }

        private void Grid_LoadedRowPresenter(object sender, C1.WPF.DataGrid.DataGridRowEventArgs e)
        {
            if (grid.Selection.SelectedRows.Count > 0)
                if (e.Row is DataGridGroupRow grp)
                    if(grp.Rows.Any(x => x.DataItem == grid.Selection.SelectedRows[0].DataItem))
                        UpdateCurrentGroupBackground(e.Row.Index, Brushes.Red);
            Debug.WriteLine(e.Row);
        }

        private void SelectionChanged(object sender, C1.WPF.DataGrid.DataGridSelectionChangedEventArgs e)
        {
            if (e.RemovedRanges.Count > 0)
            {
                UpdateCurrentGroupBackground(e.RemovedRanges.First().Rows.First().Index, null);
            }

            
            if (e.AddedRanges.Count > 0)
            {
                UpdateCurrentGroupBackground(e.AddedRanges.First().Rows.First().Index, Brushes.Red);
            }             
        }

        public void UpdateCurrentGroupBackground(int index, SolidColorBrush brush)
        {
            var first = true;
            var level = -1;
            for (int i = index; i >= 0; i--)
            {
                if (grid.Rows[i] is DataGridGroupRow)
                {
                    if (first)
                    {
                        level = (grid.Rows[i] as DataGridGroupRow).Level;
                        first = false;
                    }
                    if (level == (grid.Rows[i] as DataGridGroupRow).Level)
                    {
                        if(grid.Rows[i].Presenter!=null)
                            grid.Rows[i].Presenter.Background = brush;
                        level--;
                    }
                }
            }
            
        }
    }
  
}
